# frozen_string_literal: true

require "is/inspectable"
require "pathname"

module Core
  module Watch
    module Callbacks
      # [public] Callback that wraps a path.
      #
      class Path < Callback
        include Is::Inspectable

        def initialize(value, **kwargs, &block)
          super(**kwargs, &block)

          @path = Pathname(value.to_s)
        end

        # [public] Return `true` if this callback matches the path.
        #
        def match?(path)
          @path == path
        end
      end
    end
  end
end
