# frozen_string_literal: true

require "is/inspectable"

module Core
  module Watch
    module Callbacks
      # [public] Callback that wraps a regular expression.
      #
      class Regexp < Callback
        include Is::Inspectable

        def initialize(regexp, **kwargs, &block)
          super(**kwargs, &block)

          @regexp = regexp
        end

        # [public] Return `true` if this callback matches the path.
        #
        def match?(path)
          @regexp.match?(path.to_s)
        end
      end
    end
  end
end
